#include <iostream>
using namespace std;
#include <stdlib.h>
#include <cstdlib>
#include <simplecpp>

/*defining all functions used*/
void boardview(int board[8][6]);
void PLAYERturn(int board[8][6],int n);
bool finish(int board[8][6],int n);
void singlePLAYER(int board[8][6]);
void computerTURN(int board[8][6]);


void explode1center(int board[8][6],int i,int j);


void explode1topedge(int board[8][6],int j);
void explode1bottomedge(int board[8][6],int j);
void explode1leftedge(int board[8][6],int i);
void explode1rightedge(int board[8][6],int i);


void explode1firstcorner(int board[8][6]);
void explode1secondcorner(int board[8][6]);
void explode1thirdcorner(int board[8][6]);
void explode1forthcorner(int board[8][6]);

void search1(int board[8][6]);
void swap(int board[8][6],int n);
void convert(int board[8][6]);

void newGAME();

/*PRE-CONDITION:all elements of board[8][6] are assigned in PLAYERturn and main*/
void boardview(int board[8][6])
{
    cout<<"   1  2  3  4  5  6  "<<endl;
    cout<<" +--+--+--+--+--+--+"<<endl;
    for(int i=0;i<8;i++)
    {
        cout<<i+1 <<"|";
        for(int j=0;j<6;j++)
        {
            if(board[i][j]%10==0)cout<<"  |";
            else if(board[i][j]>0&&board[i][j]<10)cout<<"a"<<board[i][j]<<"|";
            else if(board[i][j]>10&&board[i][j]<20)cout<<"b"<<board[i][j]-10<<"|";
            else if(board[i][j]>20&&board[i][j]<30)cout<<"c"<<board[i][j]-20<<"|";
            else if(board[i][j]>30&&board[i][j]<40)cout<<"d"<<board[i][j]-30<<"|";
            else if(board[i][j]>40&&board[i][j]<50)cout<<"e"<<board[i][j]-40<<"|";
            else if(board[i][j]>50&&board[i][j]<60)cout<<"f"<<board[i][j]-50<<"|";
            else if(board[i][j]>60&&board[i][j]<70)cout<<"g"<<board[i][j]-60<<"|";
            else if(board[i][j]>70&&board[i][j]<80)cout<<"h"<<board[i][j]-70<<"|";
        }
        cout<<endl;
        cout<<" +--+--+--+--+--+--+"<<endl;
    }
    return;
}
/*POST-CONDITION:display the whole 2D array in a form of a grid*/

/*PRE-CONDITION:all elements of board[8][6] are assigned in PLAYERturn and main and n>=1,n<=8*/
void PLAYERturn(int board[8][6],int n)
{
    cout<<"Player "<<n+1<<"'s turn: (-1 for RESTART)  "<<endl;
    int a,b;
    cin>>a;
    if(a==-1){newGAME();return;}
    cin>>b;
    if(a>8||b>6||a<1||b<1)
    {
        cout<<"Sorry, Invalid Input!!!"<<endl;
        PLAYERturn (board,n);
        return;
    }
    if(board[a-1][b-1]!=0&&(board[a-1][b-1]<10*n||board[a-1][b-1]>10*(n+1)))
    {
        cout<<"Sorry, Invalid Input!!!"<<endl;
        PLAYERturn (board,n);
        return;
    }
    else
    {
        if(board[a-1][b-1]==0)board[a-1][b-1]=10*n+1;
        else board[a-1][b-1]++;
    }
    return;
}
/*POST-CONDITION:edits the value for board[8][6] according to inputs of user*/

/*PRE-CONDITION:all elements of board[8][6] are assigned in PLAYERturn and main and n>=1,n<=8*/
bool finish(int board[8][6],int n)
{
    int m=0;
    for(int i=0;i<8;i++)
    {
        for(int j=0;j<6;j++)
        {
            if(board[i][j]>10*n&&board[i][j]<10*(n+1))m++;
        }
    }
    if(m==0)return 1;
    else return 0;
}
/*POST-CONDITION:checks if the game finishes??*/

/*PRE-CONDITION:all elements of board[8][6] are assigned in PLAYERturn and main*/
void singlePLAYER(int board[8][6])
{
    PLAYERturn(board,0);
    convert(board);
    search1(board);
    convert(board);
    system("cls");
    boardview(board);
    for(;;)
    {
        cout<<"Computer's turn:"<<endl;
        computerTURN(board);
        convert(board);
        swap(board,1);
        convert(board);
        search1(board);
        convert(board);
        swap(board,1);
        convert(board);
        wait(1.5);
        system("cls");
        boardview(board);
        if(finish(board,0))
        {
            cout<<"Sorry,Computer is the winner!!!"<<endl;
            break;
        }
        if(finish(board,1))
        {
            cout<<"Congrates,you are the winner!!!"<<endl;
            break;
        }
        PLAYERturn(board,0);
        convert(board);
        search1(board);
        convert(board);
        system("cls");
        boardview(board);
        if(finish(board,0))
        {
            cout<<"Sorry,Computer is the winner!!!"<<endl;
            break;
        }
        if(finish(board,1))
        {
            cout<<"Congrates,you are the winner!!!"<<endl;
            break;
        }
    }
    return;
}
/*POST-CONDITION:generates code for single player v/s computer*/

/*PRE-CONDITION:all elements of board[8][6] are assigned in PLAYERturn and main*/
void computerTURN(int board[8][6])
{
    for(int p=0;p<8;p++)
    {
        for(int q=0;q<6;q++)
        {
            if(board[p][q]==13){board[p][q]++;return;}
            else if(board[p][q]==12){board[p][q]++;return;}
            else if(board[p][q]==11){board[p][q]++;return;}
        }
    }
    int r=rand()%8;
    int s=rand()%6;
    if(board[r][s]<10&&board[r][s]>0){computerTURN(board);return;}
    else board[r][s]=11;
    return;
}
/*POST-CONDITION:generates code for random input from computer*/

/*PRE-CONDITION:all elements of board[8][6] are assigned in PLAYERturn and main*/
void explode1bottomedge(int board[8][6],int j)
{
    if(board[7][j]>2&&board[7][j]<11)
    {
        board[7][j]-=3;
        if(j==1)
        {
            if(board[7][0]<11)board[7][0]++;
            else board[7][0]=board[7][0]%10+1;
            if(board[7][2]<11)board[7][2]++;
            else board[7][2]=board[7][2]%10+1;
            if(board[6][1]<11)board[6][1]++;
            else board[6][1]=board[6][1]%10+1;
            convert(board);
            if(board[7][0]>1&&board[7][0]<11)explode1thirdcorner(board);
            if(board[7][2]>2&&board[7][2]<11)explode1bottomedge(board,2);
            if(board[6][1]>3&&board[6][1]<11)explode1center(board,6,1);
        }
        if(j==4)
        {
            if(board[7][5]<11)board[7][5]++;
            else board[7][5]=board[7][5]%10+1;
            if(board[7][3]<11)board[7][3]++;
            else board[7][3]=board[7][3]%10+1;
            if(board[6][4]<11)board[6][4]++;
            else board[6][4]=board[6][4]%10+1;
            convert(board);
            if(board[7][5]>1&&board[7][5]<11)explode1forthcorner(board);
            if(board[7][3]>2&&board[7][3]<11)explode1bottomedge(board,3);
            if(board[6][4]>3&&board[6][4]<11)explode1center(board,6,4);
        }
        if(j==2||j==3)
        {
            if(board[7][j-1]<11)board[7][j-1]++;
            else board[7][j-1]=board[7][j-1]%10+1;
            if(board[7][j+1]<11)board[7][j+1]++;
            else board[7][j+1]=board[7][j+1]%10+1;
            if(board[6][j]<11)board[6][j]++;
            else board[6][j]=board[6][j]%10+1;
            convert(board);
            if(board[7][j-1]>2&&board[7][j-1]<11)explode1bottomedge(board,j-1);
            if(board[7][j+1]>2&&board[7][j+1]<11)explode1bottomedge(board,j+1);
            if(board[6][j]>3&&board[6][j]<11)explode1center(board,6,j);
        }
    }
    return;
}
/*POST-CONDITION:explodes element in the bottom edge*/

/*PRE-CONDITION:all elements of board[8][6] are assigned in PLAYERturn and main*/
void explode1leftedge(int board[8][6],int i)
{
    if(board[i][0]>2&&board[i][0]<11)
    {
        board[i][0]-=3;
        if(i==1)
        {
            if(board[0][0]<11)board[0][0]++;
            else board[0][0]=board[0][0]%10+1;
            if(board[2][0]<11)board[2][0]++;
            else board[2][0]=board[2][0]%10+1;
            if(board[1][1]<11)board[1][1]++;
            else board[1][1]=board[1][1]%10+1;
            convert(board);
            if(board[0][0]>1&&board[0][0]<11)explode1firstcorner(board);
            if(board[2][0]>2&&board[2][0]<11)explode1leftedge(board,2);
            if(board[1][1]>3&&board[1][1]<11)explode1center(board,1,1);
        }
        if(i==6)
        {
            if(board[7][0]<11)board[7][0]++;
            else board[7][0]=board[7][0]%10+1;
            if(board[5][0]<11)board[5][0]++;
            else board[5][0]=board[5][0]%10+1;
            if(board[6][1]<11)board[6][1]++;
            else board[6][1]=board[6][1]%10+1;
            convert(board);
            if(board[7][0]>1&&board[7][0]<11)explode1thirdcorner(board);
            if(board[5][0]>2&&board[5][0]<11)explode1leftedge(board,5);
            if(board[6][1]>3&&board[6][1]<11)explode1center(board,6,1);
        }
        if(i!=1&&i!=6)
        {
            if(board[i-1][0]<11)board[i-1][0]++;
            else board[i-1][0]=board[i-1][0]%10+1;
            if(board[i+1][0]<11)board[i+1][0]++;
            else board[i+1][0]=board[i+1][0]%10+1;
            if(board[i][1]<11)board[i][1]++;
            else board[i][1]=board[i][1]%10+1;
            convert(board);
            if(board[i-1][0]>2&&board[i-1][0]<11)explode1leftedge(board,i-1);
            if(board[i+1][0]>2&&board[i+1][0]<11)explode1leftedge(board,i+1);
            if(board[i][1]>3&&board[i][1]<11)explode1center(board,i,1);
        }
    }
    return;
}
/*POST-CONDITION:explodes element in the left edge*/

/*PRE-CONDITION:all elements of board[8][6] are assigned in PLAYERturn and main*/
void explode1rightedge(int board[8][6],int i)
{
    if(board[i][5]>2&&board[i][5]<11)
    {
        board[i][5]-=3;
        if(i==1)
        {
            if(board[0][5]<11)board[0][5]++;
            else board[0][5]=board[0][5]%10+1;
            if(board[2][5]<11)board[2][5]++;
            else board[2][5]=board[2][5]%10+1;
            if(board[1][4]<11)board[1][4]++;
            else board[1][4]=board[1][4]%10+1;
            convert(board);
            if(board[0][5]>1&&board[0][5]<11)explode1secondcorner(board);
            if(board[2][5]>2&&board[2][5]<11)explode1rightedge(board,2);
            if(board[1][4]>3&&board[1][4]<11)explode1center(board,1,4);
        }
        if(i==6)
        {
            if(board[7][5]<11)board[7][5]++;
            else board[7][5]=board[7][5]%10+1;
            if(board[5][5]<11)board[5][5]++;
            else board[5][5]=board[5][5]%10+1;
            if(board[6][4]<11)board[6][4]++;
            else board[6][4]=board[6][4]%10+1;
            convert(board);
            if(board[7][5]>1&&board[7][5]<11)explode1forthcorner(board);
            if(board[5][5]>2&&board[5][5]<11)explode1rightedge(board,5);
            if(board[6][4]>3&&board[6][4]<11)explode1center(board,6,4);
        }
        if(i!=1&&i!=6)
        {
            if(board[i-1][5]<11)board[i-1][5]++;
            else board[i-1][5]=board[i-1][5]%10+1;
            if(board[i+1][5]<11)board[i+1][5]++;
            else board[i+1][5]=board[i+1][5]%10+1;
            if(board[i][4]<11)board[i][4]++;
            else board[i][4]=board[i][4]%10+1;
            convert(board);
            if(board[i-1][5]>2&&board[i-1][5]<11)explode1rightedge(board,i-1);
            if(board[i+1][5]>2&&board[i+1][5]<11)explode1rightedge(board,i+1);
            if(board[i][4]>3&&board[i][4]<11)explode1center(board,i,4);
        }
    }
    return;
}
/*POST-CONDITION:explodes element in the right edge*/

/*PRE-CONDITION:all elements of board[8][6] are assigned in PLAYERturn and main*/
void explode1topedge(int board[8][6],int j)
{
    if(board[0][j]>2&&board[0][j]<11)
    {
        board[0][j]-=3;
        if(j==1)
        {
            if(board[0][0]<11)board[0][0]++;
            else board[0][0]=board[0][0]%10+1;
            if(board[0][2]<11)board[0][2]++;
            else board[0][2]=board[0][2]%10+1;
            if(board[1][1]<11)board[1][1]++;
            else board[1][1]=board[1][1]%10+1;
            convert(board);
            if(board[0][0]>1&&board[0][0]<11)explode1firstcorner(board);
            if(board[0][2]>2&&board[0][2]<11)explode1topedge(board,2);
            if(board[1][1]>3&&board[1][1]<11)explode1center(board,1,1);
        }
        if(j==4)
        {
            if(board[0][5]<11)board[0][5]++;
            else board[0][5]=board[0][5]%10+1;
            if(board[0][3]<11)board[0][3]++;
            else board[0][3]=board[0][3]%10+1;
            if(board[1][4]<11)board[1][4]++;
            else board[1][4]=board[1][4]%10+1;
            convert(board);
            if(board[0][5]>1&&board[0][5]<11)explode1secondcorner(board);
            if(board[0][3]>2&&board[0][3]<11)explode1topedge(board,3);
            if(board[1][4]>3&&board[1][4]<11)explode1center(board,1,4);
        }
        if(j==2||j==3)
        {
            if(board[0][j-1]<11)board[0][j-1]++;
            else board[0][j-1]=board[0][j-1]%10+1;
            if(board[0][j+1]<11)board[0][j+1]++;
            else board[0][j+1]=board[0][j+1]%10+1;
            if(board[1][j]<11)board[1][j]++;
            else board[1][j]=board[1][j]%10+1;
            convert(board);
            if(board[0][j-1]>2&&board[0][j-1]<11)explode1topedge(board,j-1);
            if(board[0][j+1]>2&&board[0][j+1]<11)explode1topedge(board,j+1);
            if(board[1][j]>3&&board[1][j]<11)explode1center(board,1,j);
        }
    }
    return;
}
/*POST-CONDITION:explodes element in the top edge*/

/*PRE-CONDITION:all elements of board[8][6] are assigned in PLAYERturn and main*/
void explode1firstcorner(int board[8][6])
{
    if(board[0][0]>1&&board[0][0]<11)
    {
        board[0][0]-=2;
        if(board[0][1]<11)board[0][1]++;
        else board[0][1]=board[0][1]%10+1;
        if(board[1][0]<11)board[1][0]++;
        else board[1][0]=board[1][0]%10+1;
        convert(board);
        if(board[0][1]>2)explode1topedge(board,1);
        if(board[1][0]>2)explode1leftedge(board,1);
    }
    return;
}
/*POST-CONDITION:explodes element in the top left corner*/

/*PRE-CONDITION:all elements of board[8][6] are assigned in PLAYERturn and main*/
void explode1secondcorner(int board[8][6])
{
    if(board[0][5]>1&&board[0][5]<11)
    {
        board[0][5]-=2;
        if(board[0][4]<11)board[0][4]++;
        else board[0][4]=board[0][4]%10+1;
        if(board[1][5]<11)board[1][5]++;
        else board[1][5]=board[1][5]%10+1;
        convert(board);
        if(board[0][4]>2&&board[0][4]<11)explode1topedge(board,4);
        if(board[1][5]>2&&board[1][5]<11)explode1rightedge(board,1);
    }
    return;
}
/*POST-CONDITION:explodes element in the top right corner*/

/*PRE-CONDITION:all elements of board[8][6] are assigned in PLAYERturn and main*/
void explode1thirdcorner(int board[8][6])
{
    if(board[7][0]>1&&board[7][0]<11)
    {
        board[7][0]-=2;
        if(board[7][1]<11)board[7][1]++;
        else board[7][1]=board[7][1]%10+1;
        if(board[6][0]<11)board[6][0]++;
        else board[6][0]=board[6][0]%10+1;
        convert(board);
        if(board[7][1]>2&&board[7][1]<11)explode1bottomedge(board,1);
        if(board[6][0]>2&&board[6][0]<11)explode1leftedge(board,6);
    }
    return;
}
/*POST-CONDITION:explodes element in the bottom left corner*/

/*PRE-CONDITION:all elements of board[8][6] are assigned in PLAYERturn and main*/
void explode1forthcorner(int board[8][6])
{
    if(board[7][5]>1&&board[7][5]<11)
    {
        board[7][5]-=2;
        if(board[7][4]<11)board[7][4]++;
        else board[7][4]=board[7][4]%10+1;
        if(board[6][5]<11)board[6][5]++;
        else board[6][5]=board[6][5]%10+1;
        convert(board);
        if(board[7][4]>2&&board[7][4]<11)explode1bottomedge(board,4);
        if(board[6][5]>2&&board[6][5]<11)explode1rightedge(board,6);
    }
    return;
}
/*POST-CONDITION:explodes element in the bottom right corner*/

/*PRE-CONDITION:all elements of board[8][6] are assigned in PLAYERturn and main*/
void explode1center(int board[8][6],int i,int j)
{
    if(board[i][j]>3&&board[i][j]<11)
    {
        board[i][j]-=4;
        convert(board);
        if(i!=1&&i!=6&&j!=1&&j!=4)
        {
            if(board[i-1][j]<11) board[i-1][j]++;
            else board[i-1][j]=board[i-1][j]%10+1;
            if(board[i][j+1]<11) board[i][j+1]++;
            else board[i][j+1]=board[i][j+1]%10+1;
            if(board[i+1][j]<11) board[i+1][j]++;
            else board[i+1][j]=board[i+1][j]%10+1;
            if(board[i][j-1]<11) board[i][j-1]++;
            else board[i][j-1]=board[i][j-1]%10+1;
            convert(board);
            if(board[i-1][j]>3&&board[i-1][j]<11)explode1center(board,i-1,j);
            if(board[i][j+1]>3&&board[i][j+1]<11)explode1center(board,i,j+1);
            if(board[i+1][j]>3&&board[i+1][j]<11)explode1center(board,i+1,j);
            if(board[i][j-1]>3&&board[i][j-1]<11)explode1center(board,i,j-1);
        }
        else if(i==1&&j!=1&&j!=4)
        {
            if(board[i-1][j]<11) board[i-1][j]++;
            else board[i-1][j]=board[i-1][j]%10+1;
            if(board[i][j+1]<11) board[i][j+1]++;
            else board[i][j+1]=board[i][j+1]%10+1;
            if(board[i+1][j]<11) board[i+1][j]++;
            else board[i+1][j]=board[i+1][j]%10+1;
            if(board[i][j-1]<11) board[i][j-1]++;
            else board[i][j-1]=board[i][j-1]%10+1;
            convert(board);
            if(board[0][j]>2&&board[i-1][j]<11)explode1topedge(board,j);
            if(board[i][j+1]>3&&board[i][j+1]<11)explode1center(board,i,j+1);
            if(board[i+1][j]>3&&board[i+1][j]<11)explode1center(board,i+1,j);
            if(board[i][j-1]>3&&board[i][j-1]<11)explode1center(board,i,j-1);
        }
        else if(i==6&&j!=1&&j!=4)
        {
            if(board[i-1][j]<11) board[i-1][j]++;
            else board[i-1][j]=board[i-1][j]%10+1;
            if(board[i][j+1]<11) board[i][j+1]++;
            else board[i][j+1]=board[i][j+1]%10+1;
            if(board[i+1][j]<11) board[i+1][j]++;
            else board[i+1][j]=board[i+1][j]%10+1;
            if(board[i][j-1]<11) board[i][j-1]++;
            else board[i][j-1]=board[i][j-1]%10+1;
            convert(board);
            if(board[i-1][j]>3&&board[i-1][j]<11)explode1center(board,i-1,j);
            if(board[i][j+1]>3&&board[i][j+1]<11)explode1center(board,i,j+1);
            if(board[7][j]>2&&board[7][j]<11)explode1bottomedge(board,j);
            if(board[i][j-1]>3&&board[i][j-1]<11)explode1center(board,i,j-1);
        }
        else if(j==1&&i!=1&&i!=6)
        {
            if(board[i-1][j]<11) board[i-1][j]++;
            else board[i-1][j]=board[i-1][j]%10+1;
            if(board[i][j+1]<11) board[i][j+1]++;
            else board[i][j+1]=board[i][j+1]%10+1;
            if(board[i+1][j]<11) board[i+1][j]++;
            else board[i+1][j]=board[i+1][j]%10+1;
            if(board[i][j-1]<11) board[i][j-1]++;
            else board[i][j-1]=board[i][j-1]%10+1;
            convert(board);
            if(board[i-1][j]>3&&board[i-1][j]<11)explode1center(board,i-1,j);
            if(board[i][j+1]>3&&board[i][j+1]<11)explode1center(board,i,j+1);
            if(board[i+1][j]>3&&board[i+1][j]<11)explode1center(board,i+1,j);
            if(board[i][0]>2&&board[i][j-1]<11)explode1leftedge(board,i);
        }
        else if(j==4&&i!=1&&i!=6)
        {
            if(board[i-1][j]<11) board[i-1][j]++;
            else board[i-1][j]=board[i-1][j]%10+1;
            if(board[i][j+1]<11) board[i][j+1]++;
            else board[i][j+1]=board[i][j+1]%10+1;
            if(board[i+1][j]<11) board[i+1][j]++;
            else board[i+1][j]=board[i+1][j]%10+1;
            if(board[i][j-1]<11) board[i][j-1]++;
            else board[i][j-1]=board[i][j-1]%10+1;
            convert(board);
            if(board[i-1][j]>3&&board[i-1][j]<11)explode1center(board,i-1,j);
            if(board[i][5]>2&&board[i][j+1]<11)explode1rightedge(board,i);
            if(board[i+1][j]>3&&board[i+1][j]<11)explode1center(board,i+1,j);
            if(board[i][j-1]>3&&board[i][j-1]<11)explode1center(board,i,j-1);
        }
        else if(i==1&&j==1)
        {
            if(board[i-1][j]<11) board[i-1][j]++;
            else board[i-1][j]=board[i-1][j]%10+1;
            if(board[i][j+1]<11) board[i][j+1]++;
            else board[i][j+1]=board[i][j+1]%10+1;
            if(board[i+1][j]<11) board[i+1][j]++;
            else board[i+1][j]=board[i+1][j]%10+1;
            if(board[i][j-1]<11) board[i][j-1]++;
            else board[i][j-1]=board[i][j-1]%10+1;
            convert(board);
            if(board[0][1]>2&&board[0][1]<11)explode1topedge(board,1);
            if(board[1][2]>3&&board[1][2]<11)explode1center(board,1,2);
            if(board[2][1]>3&&board[2][1]<11)explode1center(board,2,1);
            if(board[1][0]>2&&board[1][0]<11)explode1leftedge(board,1);
        }
        else if(i==1&&j==4)
        {
            if(board[i-1][j]<11) board[i-1][j]++;
            else board[i-1][j]=board[i-1][j]%10+1;
            if(board[i][j+1]<11) board[i][j+1]++;
            else board[i][j+1]=board[i][j+1]%10+1;
            if(board[i+1][j]<11) board[i+1][j]++;
            else board[i+1][j]=board[i+1][j]%10+1;
            if(board[i][j-1]<11) board[i][j-1]++;
            else board[i][j-1]=board[i][j-1]%10+1;
            convert(board);
            if(board[0][4]>2&&board[0][4]<11)explode1topedge(board,4);
            if(board[1][5]>2&&board[1][5]<11)explode1rightedge(board,1);
            if(board[2][4]>3&&board[2][4]<11)explode1center(board,2,4);
            if(board[1][3]>3&&board[1][3]<11)explode1center(board,1,3);
        }
        else if(i==6&&j==1)
        {
            if(board[i-1][j]<11) board[i-1][j]++;
            else board[i-1][j]=board[i-1][j]%10+1;
            if(board[i][j+1]<11) board[i][j+1]++;
            else board[i][j+1]=board[i][j+1]%10+1;
            if(board[i+1][j]<11) board[i+1][j]++;
            else board[i+1][j]=board[i+1][j]%10+1;
            if(board[i][j-1]<11) board[i][j-1]++;
            else board[i][j-1]=board[i][j-1]%10+1;
            convert(board);
            if(board[5][1]>3&&board[5][1]<11)explode1center(board,5,1);
            if(board[6][2]>3&&board[6][2]<11)explode1center(board,6,2);
            if(board[7][1]>2&&board[7][1]<11)explode1bottomedge(board,1);
            if(board[6][0]>2&&board[6][0]<11)explode1leftedge(board,6);
        }
        else if(i==6&&j==4)
        {
            if(board[i-1][j]<11) board[i-1][j]++;
            else board[i-1][j]=board[i-1][j]%10+1;
            if(board[i][j+1]<11) board[i][j+1]++;
            else board[i][j+1]=board[i][j+1]%10+1;
            if(board[i+1][j]<11) board[i+1][j]++;
            else board[i+1][j]=board[i+1][j]%10+1;
            if(board[i][j-1]<11) board[i][j-1]++;
            else board[i][j-1]=board[i][j-1]%10+1;
            convert(board);
            if(board[5][4]>3&&board[5][4]<11)explode1center(board,5,4);
            if(board[6][5]>2&&board[6][5]<11)explode1rightedge(board,6);
            if(board[7][4]>2&&board[7][4]<11)explode1bottomedge(board,4);
            if(board[6][3]>3&&board[6][3]<11)explode1center(board,6,3);
        }
    }
    return;
}
/*POST-CONDITION:explodes element in the center*/

/*PRE-CONDITION:all elements of board[8][6] are assigned in PLAYERturn and main*/
void search1(int board[8][6])
{
    convert(board);
    for(int i=1;i<7;i++)
    {
        for(int j=1;j<5;j++)
        {
            if(board[i][j]>3&&board[i][j]<11)
            {
                explode1center (board,i,j);
            }
        }
    }
    if(board[0][0]>1&&board[0][0]<11)explode1firstcorner(board);
    if(board[0][5]>1&&board[0][5]<11)explode1secondcorner(board);
    if(board[7][0]>1&&board[7][0]<11)explode1thirdcorner(board);
    if(board[7][5]>1&&board[7][5]<11)explode1forthcorner(board);
    for(int j=1;j<5;j++)
    {
        if(board[7][j]>2&&board[7][j]<11)explode1bottomedge(board,j);
    }
    for(int j=1;j<5;j++)
    {
        if(board[0][j]>2&&board[0][j]<11)explode1topedge(board,j);
    }
    for(int i=1;i<7;i++)
    {
        if(board[i][0]>2&&board[i][0]<11)explode1leftedge(board,i);
    }
    for(int i=1;i<7;i++)
    {
        if(board[i][5]>2&&board[i][5]<11)explode1rightedge(board,i);
    }
    return;
}
/*POST-CONDITION:searches if an element is able to upload or not??*/

/*PRE-CONDITION:all elements of board[8][6] are assigned in PLAYERturn and main and n>=0,n<8*/
void swap(int board[8][6],int n)
{
    for(int i=0;i<8;i++)
    {
        for(int j=0;j<6;j++)
        {
            if(board[i][j]>0&&board[i][j]<10)board[i][j]+=10*n;
            else if(board[i][j]>10*n&&board[i][j]<10*(n+1))board[i][j]-=10*n;
        }
    }
    return;
}
/*POST-CONDITION:swaps the elements of required player with elements of 1st player*/

/*PRE-CONDITION:all elements of board[8][6] are assigned in PLAYERturn and main*/
void convert(int board[8][6])
{
    for(int i=0;i<8;i++)
    {
        for(int j=0;j<6;j++)
        {
            if(board[i][j]%10==0)board[i][j]=0;
        }
    }
    return;
}
/*POST-CONDITION:converts all elements into 0 whose value is same as 0*/

void newGAME()
{
    system("cls");
    int n;
    cout<<"Give number of players (between 1 to 8):"<<endl;
    cin>>n;//takes number of players
    system("cls");
    if(n<1||n>8){cout<<"INVALID INPUT"<<endl;return;}//for invalid inputs of n
    int board[8][6];
    int i,j;
    for(i=0;i<8;i++){for(j=0;j<6;j++)board[i][j]=0;}//initializing all elements to 0
    boardview (board);//displays the array
    if(n!=1)//n!=1 implies multiplayer
    {
        int a,b;//for 1st turn of 1st player
        cout<<"Player 1's turn: (-1 for restart)"<<endl;
        cin>>a;
        if(a==-1){newGAME();return;}
        cin>>b;
        board[a-1][b-1]=1;
        system("cls");
        boardview (board);
        for(int i=1;i<n;i++)
        {
            PLAYERturn (board,i);//for 1st turn of other players
            convert(board);//converts all elements to 0 whose value is same as 0
            swap (board,i);//swaps the elements of required player with elements of 1st player
            convert (board);
            search1 (board);//searches if an element is able to explode or not??
            convert(board);
            swap (board,i);
            convert (board);
            system("cls");//deletes the previous screen
            boardview (board);//displays the whole array
        }
        for(;;)
        {
            for(i=0;i<n;i++)
            {
                if(finish(board,i))continue;//skips the chance of those who are out
                PLAYERturn (board,i);
                convert(board);
                swap (board,i);
                convert (board);
                search1 (board);
                convert(board);
                swap (board,i);
                convert (board);
                system("cls");
                boardview (board);
                for(int j=0;j<n;j++)//checks if any player is out or not
                {
                    if(finish(board,j))cout<<"Sorry,Player"<<j+1<<"is out."<<endl;
                }
                int d=0,e;
                for(int j=0;j<n;j++)//checks if the game ends or not
                {
                    if(!finish(board,j)){d++;e=j;}
                }
                if(d==1){cout<<"Congrats,Player "<<e+1<<" is the winner!!!"<<endl;return ;}//ends the game with the winning player
            }
        }
    }
    else singlePLAYER(board);//n=1 implies single player v/s computer
    return ;
}
int main()
{
    cout<<"1. NEW GAME                       2. CREDITS                       3. EXIT"<<endl;
    int f;
    cin>>f;
    if(f==1)newGAME();
    if(f==2){system("cls");cout<<"1.KUNJ PATEL"<<endl<<"2.AKSHAY RAUT"<<endl<<"3.VAIBHAV JAIN"<<endl;}
    if(f==3)return 0;
}



